﻿function view_onOpen()
{
beginAnimation("anim()", 100, 255, 1500);
fetch_News(plugin_state_url);
}

function check_key()
{
if(event.keyCode==13)
   search_news();
}

function anim()
{
cnArea.opacity=event.value;
gnews_bg.opacity=event.value;
search_button.opacity=event.value;
q.opacity=event.value
}

//---------------------


var httpReq = null;
plugin.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);

var interval = 60;
var plugin_state = 1;//0 - news showing news types ; 1-showing news headlines
var current_cc="us"
var plugin_state_url = "http://news.google.com/news?ned=" + current_cc + "&topic=h&output=rss";

setInterval(OnTimer, 1000 * 60 * interval);

SetDefaultOptions();

function OnTimer() {
  if(plugin_state==0)
     Show_NewsTypes();
  else{
     FetchAndParse(plugin_state_url);
  }
}
var selectedCountryCode;
var selectedCountry;

//---- Functions  and Variables to manage the options dialog
//All Countries and codes
var countries_names = new Array("Argentina","Australia","België","Belgique","Brasil","Canada English","Canada Français","Chile","Colombia","Cuba","Deutschland","España","Estados Unidos","France","India","Ireland","Italia","México","Nederland","New Zealand","Österreich","Perú","Portugal","Schweiz","South Africa","Suisse","U.K.","U.S.","Venezuela","China","Hong Kong","Japan","Korea","Taiwan","Israel","Arabic");
var countries_codes = new Array("es_ar","au","nl_be","fr_be","pt-BR_br","ca","fr_ca","es_cl","es_co","es_cu","de","es","es_us","fr","in","en_ie","it","es_mx","nl_nl","nz","de_at","es_pe","pt-PT_pt","de_ch","en_za","fr_ch","uk","us","es_ve","cn","hk","jp","kr","tw","iw_il","ar_me");

plugin.onShowOptionsDlg = ShowOptionsDlg; // handler for options dialog

function SetDefaultOptions() {
  if (options.GetValue("country") == "") {
    PutCountry("U.S.");
  }
}
function GetSelectedCountryCode() {
  var ctr = GetCountry();
  var i = 0;
  for(i=0;i<countries_names.length;i++){
    if(countries_names[i]==ctr)
     break;
  }
  return countries_codes[i];

}
function GetCountry() {
  return options.GetValue("country");
}

function PutCountry(val) {
  options.PutValue("country", val);
}

function ShowOptionsDlg(wnd) {
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Country", 10, 10, 280, 30);
  var list = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "country", countries_names, 10, 35, 280, 2000);
  list.value = GetCountry();
  // handlers
  wnd.onClose = OptionsDlgClosed;
  
}

function OptionsDlgClosed(wnd, code) {
  if (code == gddIdOK) {
    var list = wnd.GetControl("country");
    PutCountry(list.value);
    selectedCountry = list.value;
    selectedCountryCode = GetSelectedCountryCode();
    OnTimer();  // to refresh items and add again
  }
}


// Event listener for Each category link
function fetch_News(main_url) {
   var url = main_url;
   plugin_state=1;
   plugin_state_url = url;//to preserve plugin state 
   FetchAndParse(url);
   
}


//Fetches the Rss feed from the selected site.
function FetchAndParse(url) {
     
  httpReq = new XMLHttpRequest();
  httpReq.onreadystatechange = OnRssFeed;
  httpReq.open("GET", url, true);
  httpReq.send();
}

function OnRssFeed() {
   if(httpReq.readyState==1){
   loading.opacity=255;
   netconn.opacity=0;
   }
   if(httpReq.readyState==4){
      loading.opacity=0;
      if(httpReq.status!=200){
         netconn.opacity=255;
	}
      if(httpReq.status==200){
         var doc = new DOMDocument();
         doc.loadXML(httpReq.responseText);
         var items = doc.getElementsByTagName("item");
         if(items.length>0) {
	    cnArea.removeAllContentItems();
            cnArea.contentFlags = gddContentFlagHaveDetails;
            for(var i=items.length-1;i>=0;i--){
               //parse the item
               var title, reporter ,link, pubDate, desc;
               for (var node = items[i].firstChild; node != null; node = node.nextSibling) {
                   if (node.nodeName == "title")
                      title = node.firstChild.nodeValue;
                   else 
                   if(node.nodeName== "link")
                      link = node.firstChild.nodeValue;
                   else
                   if(node.nodeName == "pubDate")
                      pubDate = node.firstChild.nodeValue;
                   else
                   if(node.nodeName == "description")
                      desc = node.firstChild.nodeValue;
                }
                   
                var curItem = new ContentItem();
                curItem.layout = gddContentItemLayoutNews;
                curItem.onDetailsView = OnDetailsView;
                cnArea.AddContentItem(curItem, gddItemDisplayInSidebar);
                
                var titleStr = new String(title);

                titleStr = titleStr.replace(/&#[0-9]+;/g," ");
                titleStr = titleStr.replace(/&quot;/g,"'");
		titleStr = titleStr.replace(/&amp;/g,"&");
                var indx_bar = titleStr.lastIndexOf("-");
                curItem.heading = titleStr.substring(0,indx_bar-1);
		curItem.source = titleStr.substring(indx_bar+1, titleStr.length);
                curItem.snippet = desc;      
                var tm = new Date(pubDate);
                tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
                curItem.time_created = tm.getVarDate();
                curItem.open_command = link;//to open the browser  
            }                

         }
      }
   }
}

function top_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=h&output=rss";
fetch_News(pass_url);
}

function w_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=w&output=rss";
fetch_News(pass_url);
}

function u_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=n&output=rss";
fetch_News(pass_url);
}

function buss_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=b&output=rss";
fetch_News(pass_url);
}

function sci_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=t&output=rss";
fetch_News(pass_url);
}

function health_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=m&output=rss";
fetch_News(pass_url);
}

function sport_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=s&output=rss";
fetch_News(pass_url);
}

function ent_click()
{
var current_cc=GetSelectedCountryCode();
var pass_url = "http://news.google.com/news?ned=" + current_cc + "&topic=e&output=rss";
fetch_News(pass_url);
}

function search_news()
{
netconn.opacity=255;
var pass_url = "http://news.google.com/news?q=" + q.value + "&output=rss";
fetch_News(pass_url);
}


//Details view handler. Formats the html code and displays
function OnDetailsView(item) {
  
  var htmlcontent = "<html><head></head><body>";
  htmlcontent += item.snippet;
  htmlcontent += "</body></html>";
  
  var control = new DetailsView();
 
  control.SetContent(item.source, item.time_created, htmlcontent, true, item.layout);
  control.html_content = true;

  var details = new Object();
  details.details_control = control;
  details.flags=gddDetailsViewFlagShareWithButton+gddDetailsViewFlagToolbarOpen;
  return details;
}